;BumpRobot.bas

;**Variables**
temp 				var 		word
PushButton			var			in6
LeftBumper			var			in15
RightBumper			var			in13

;**Constants**
LeftLED				con			P0
RightLED			con			P12
RightMotor			con			P11
LeftMotor			con			P1

;Initialise Motor outputs
	high RightMotor
	high LeftMotor
	pause 50
	
StopRobot:
	gosub StopWheels						;Call the subroutine StopWheels
	low LeftLED								;Turn LeftLED off
	low RightLED							;Turn RightLED off
	pause 250								;Pause - Do nothing for 250mS
       if PushButton = 1 then StopRobot		
	
Loop:	
      if PushButton = 1 then Main			;If Push  Button is pressed goto the main program
	pause 10								;Pause - Do nothing for 10mS
	goto Loop								;Loop around to Loop 	
	
main:
	toggle LeftLED							;Swap the state of Left LED
	toggle RightLED							;Swap the state of Right LED
	gosub Forward							;Call the subroutine "Forward"
	pause 200								;Pause - Do nothing for 200mS
	if LeftBumper = 1 then BackwardSpinRight;If the right bumper sensor is bumped BackwardSpinRight
	if RightBumper = 1 then BackwardSpinLeft;If the right bumper sensor is bumped BackwardSpinLeft
	if PushButton = 1 then StopRobot		;If Push Button is pressed goto StopRobot
	goto main								;Loop around to Main

BackwardSpinRight:
	gosub StopWheels						;Call the subroutine StopWheels
	gosub Backward							;Call the subroutine Backward
	gosub SpinRight							;Call the subroutine SpinRight
	goto main								;Loop around to Main
	
BackwardSpinLeft:
	gosub StopWheels						;Call the subroutine StopWheels
	gosub Backward							;Call the subroutine Backward
	gosub SpinLeft							;Call the subroutine SpinLeft
	goto main								;Loop around to Main

Forward:		
	Serout LeftMotor,i2400,["A",150]		;Drive motor Anticlockwise at 150 
	Serout RightMotor,i2400,["C",150]		;Drive motor Clockwise at 150 
	Return

Backward:	
	pause 50
	Serout LeftMotor,i2400,["C",150]		;Drive motor Clockwise at 150 
	Serout RightMotor,i2400,["A",150]		;Drive motor Anticlockwise at 150 
		for temp = 1 to 25	
		pause 7
		if PushButton = 1 then StopRobot	;If Push Button is pressed goto StopRobot
		next
	gosub StopWheels
	pause 50
	Return

SpinRight:
	Serout LeftMotor,i2400,["A",150]		;Drive motor Anticlockwise at 150 
	Serout RightMotor,i2400,["A",150]		;Drive motor Anticlockwise at 150 
		for temp = 1 to 25
		pause 15
		if PushButton = 1 then StopRobot	;If Push Button is pressed goto StopRobot
		next
	gosub StopWheels
	pause 50
	return

SpinLeft:
	Serout LeftMotor,i2400,["C",150]		;Drive motor Clockwise at 150 
	Serout RightMotor,i2400,["C",150]		;Drive motor Clockwise at 150 
		for temp = 1 to 25
		pause 15
		if PushButton = 1 then StopRobot	;If Push Button is pressed goto StopRobot
		next
	gosub StopWheels
	pause 50
	return

StopWheels:
	pulsout LeftMotor,6000					;Brake Left Motor
	pulsout RightMotor,6000					;Brake Right Motor
	Return
	end