;IRControlledRobot.bas

;**VARIABLES**
temp 					var			word
irdata 					var			word
headerlength			var			word
pulselength				var			word
leftspeed				var			word
rightspeed				var			word

;**CONSTANTS**
IR_DATA_PIN				con			P14
LeftMotor				con			P13
RightMotor				con			P15
LED_Pin					con			P6

;**Initialise Motor Outputs**
	High LeftMotor
	High RightMotor
	pause 500

Main:
	low LED_Pin
	gosub wait										;Call the wait subroutine
	if irdata <> 0 then gosub TestIRData
	irdata = 0
	goto Main
wait:												
	irdata = 0										;clear irdata
	pulsin IR_DATA_PIN,0,WaitEnd,1,headerlength		;wait for a pulse, if one comes 
													;put the length in 'headerlength' 
	if headerlength > 2250 then readir				;check if the pulse is greater 
													;than 2250uS if so goto 'readir'
WaitEnd:
	irdata = 0										;clear irdata
	return

;Start reading the pulses==================================================
readir:
	if headerlength > 2750 then WaitEnd				;check if the pulse is less than 
													;2750uS, if so goto 'WaitEnd'
pulse1:
	pulsin IR_DATA_PIN,0,WaitEnd,1,pulselength		;wait for the next pulse and 
													;store the length in 'pulselength'
	if pulselength < 400 then WaitEnd				;if 'pulselength' is less than 
													;400uS then goto 'WaitEnd'
	if pulselength < 1000 then pulse2				;if 'pulselength is less than 
													;1000uS then goto 'pulse2'
	irdata = irdata + %1000000000000000				;Add a high bit 16 
pulse2:
	pulsin IR_DATA_PIN,0,WaitEnd,1,pulselength		;As above
	if pulselength < 400 then WaitEnd			
	if pulselength < 1000 then pulse3				;If less than 1000uS go to 'pulse3'	
	irdata = irdata + %100000000000000				;Add a high bit 15 
pulse3:
	pulsin IR_DATA_PIN,0,WaitEnd,1,pulselength		;As above	if pulselength < 400 then WaitEnd			
	if pulselength < 1000 then pulse4				;If less than 1000uS go to 'pulse4'	
	irdata = irdata + %10000000000000				;Add a high bit 14 
pulse4:
	pulsin IR_DATA_PIN,0,WaitEnd,1,pulselength		;As above
	if pulselength < 400 then WaitEnd			
	if pulselength < 1000 then pulse5				;If  less than 1000uS go to 'pulse5'
	irdata = irdata + %1000000000000				;Add a high bit 13 
pulse5:
	pulsin IR_DATA_PIN,0,WaitEnd,1,pulselength		;As above
	if pulselength < 400 then WaitEnd			
	if pulselength < 1000 then pulse6				;If less than 1000uS go to 'pulse6'
	irdata = irdata + %100000000000					;Add a high bit 12 
pulse6:
	pulsin IR_DATA_PIN,0,WaitEnd,1,pulselength		;As above
	if pulselength < 400 then WaitEnd			
	if pulselength < 1000 then pulse7				;If less than 1000uS go to 'pulse7'	
	irdata = irdata + %10000000000					;Add a high bit 11 
pulse7:
	pulsin IR_DATA_PIN,0,WaitEnd,1,pulselength		;As above
	if pulselength < 400 then WaitEnd			
	if pulselength < 1000 then pulse8				;If less than 1000uS go to 'pulse8'	
	irdata = irdata + %1000000000					;Add a high bit 10 
pulse8:
	pulsin IR_DATA_PIN,0,WaitEnd,1,pulselength		;As above
	if pulselength < 400 then WaitEnd			
	if pulselength < 1000 then pulse9				;If less than 1000uS go to 'pulse9'
	irdata = irdata + %100000000					;Add a high bit 9 
pulse9:
	pulsin IR_DATA_PIN,0,WaitEnd,1,pulselength		;As above
	if pulselength < 400 then WaitEnd			
	if pulselength < 1000 then pulse10				;If less than1000uS go to 'pulse10'
	irdata = irdata + %10000000						;Add a high bit 8 
pulse10:
	pulsin IR_DATA_PIN,0,WaitEnd,1,pulselength		;As above
	if pulselength < 400 then WaitEnd			
	if pulselength < 1000 then pulse11				;If less than 1000uS go to 'pulse11'
	irdata = irdata + %1000000						;Add a high bit 7 
pulse11:
	pulsin IR_DATA_PIN,0,WaitEnd,1,pulselength		;As above
	if pulselength < 400 then WaitEnd			
	if pulselength < 1000 then pulse12				;If less than1000uS go to 'pulse12'
	irdata = irdata + %100000						;Add a high bit 6 
pulse12:
	pulsin IR_DATA_PIN,0,WaitEnd,1,pulselength		;As above
	if pulselength < 400 then WaitEnd				
	if pulselength < 1000 then endreadir			;If less than1000uS end
	irdata = irdata + %10000						;Add a high bit 5 
	endreadir:
	return

TestIRData:
	High LED_Pin									;Set LED_Pin high	
	if irdata = %0000100100000000 then forward		
	if irdata = %1000100100000000 then backward
	if irdata = %0100100100000000 then twistright
	if irdata = %1100100100000000 then twistleft
	if irdata = %0010100100000000 then still
	return

forward:
	Serout LeftMotor,i2400,["A",255]  	
	Serout RightMotor,i2400,["C",255]
	pulsin IR_DATA_PIN,0,ForwardEnd,1,headerlength	;whilst IR data is still coming in 
													;keep in this loop
	goto Forward
ForwardEnd:	
	gosub Still
	return

backward:
	Serout LeftMotor,i2400,["C",255]  		
	Serout RightMotor,i2400,["A",255]
	pulsin IR_DATA_PIN,0,BackwardEnd,1,headerlength	;As above 
	goto Backward
BackwardEnd:	
	gosub Still
	return

twistright:
	Serout LeftMotor,i2400,["A",255]  	
	Serout RightMotor,i2400,["A",255]	
	pulsin IR_DATA_PIN,0,TwistRightEnd,1,headerlength;As above
	goto TwistRight
TwistRightEnd:	
	gosub Still
	return

twistleft:
	Serout LeftMotor,i2400,["C",255]  		
	Serout RightMotor,i2400,["C",255]	
	pulsin IR_DATA_PIN,0,TwistLeftEnd,1,headerlength;As above
	goto TwistLeft
TwistLeftEnd:	
	gosub Still
	return

still:
	pulsout LeftMotor,6000							;Brake Left Motor
	pulsout RightMotor,6000							;Brake Right Motor
	pause 50
	return
	
	end